--use DWHSK_TARGET_PROD 
USE dwhsk_target_hist 
GO 
ALTER VIEW dbo.view_all_partitions_trg_hist AS 
-- alter view dbo.view_all_partitions_trg_prod as

SELECT 

--@pafu = 
-- pf.name ,  c.name AS ColumnName 
obj.name AS table_name , 
ps.name AS ps_name , 
'$partition.' + pf.name + '(' + c.name + ')' AS pafu , 
pf.type AS pf_type 
-- , ic.index_column_id, ic.column_id, ic.partition_ordinal
, 
c.name AS pa_col_name , 
CASE 
    WHEN prng_down.value IS NULL THEN '' 
    ELSE CASE 
    WHEN pf.type = 'R' THEN c.name + ' >= ''' + convert ( varchar ( 50 ) , prng_down.value , 20 ) + ''' ' 
    WHEN pf.type = 'L' THEN c.name + ' > ''' + convert ( varchar ( 50 ) , prng_down.value , 20 ) + ''' ' 
END 

END 
AS lower_check 
, 
CASE 
    WHEN prng_down.value IS NULL THEN '' 
    ELSE CASE 
    WHEN pf.type = 'R' THEN convert ( varchar ( 50 ) , prng_down.value , 20 ) 
    WHEN pf.type = 'L' THEN convert ( varchar ( 50 ) , prng_down.value , 20 ) 
END 
END 
AS lower_date 
, 
CASE 
    WHEN prng_up.value IS NULL THEN '' 
    ELSE CASE 
    WHEN pf.type = 'R' THEN c.name + ' < ''' + convert ( varchar ( 50 ) , prng_up.value , 20 ) + ''' ' 
    WHEN pf.type = 'L' THEN c.name + ' <= ''' + convert ( varchar ( 50 ) , prng_up.value , 20 ) + ''' ' 
END 
END 
AS upper_check 
, 
CASE 
    WHEN prng_up.value IS NULL THEN '' 
    ELSE CASE 
    WHEN pf.type = 'R' THEN convert ( varchar ( 50 ) , prng_up.value , 20 ) 
    WHEN pf.type = 'L' THEN convert ( varchar ( 50 ) , prng_up.value , 20 ) 
END 
END 
AS upper_date 
, pa.partition_number , pa.rows , ds.name AS fg_name 
/* , dbf.name as file_namee
,  8.00*dbf.size/(1024.00*1024.00) as file_size_gb 
, 8.00*dbf.max_size/(1024.00*1024.00)  as file_max_size_gb */ 
, part_size_Gb , reserved_size_Mb , used_size_Mb 
, i.index_id 
--, ic.partition_ordinal is_partitioned_column
FROM sys.indexes AS i 
LEFT JOIN sys.index_columns ic 
ON ( ic.partition_ordinal >= 0 ) -- >0 shows only partitioned tables 
AND 
( ic.index_id = i.index_id 
    AND ic.object_id = cast ( i.object_id AS int ) ) 
LEFT JOIN sys.columns c 
ON c.object_id = ic.object_id 
AND c.column_id = ic.column_id 
JOIN sys.objects obj ON i.object_id = obj.object_id 
JOIN sys.partitions pa 
ON pa.object_id = i.object_id 
AND pa.index_id = i.index_id 
LEFT JOIN sys.partition_schemes ps ON i.data_space_id = ps.data_space_id 
LEFT JOIN sys.partition_functions pf ON ps.function_id = pf.function_id 
LEFT JOIN sys.partition_range_values prng_up ON prng_up.function_id = pf.function_id 
AND prng_up.boundary_id = pa.partition_number 
LEFT JOIN 
/*      ( select OBJECT_ID , table_name, index_id,
partition_number, (1.000*tbl_size)/(1024*1024*1024)  as part_size_Gb
from  DWHSK_WAREHOUSE..DWH_SIZE_TBL_PARTITIONS_LOG 
where Database_Name = DB_NAME()
and Process_Date = ( select dateadd(day,-1,max(Process_Date )) from  DWHSK_WAREHOUSE..DWH_SIZE_TBL_PARTITIONS_LOG with(nolock) )
)  */ 
( 
    SELECT 
    object_id , 
    index_id , 
    partition_number , 
    cast ( reserved_page_count * ( 0.0078125 / 1024.00 ) AS numeric ( 18 , 2 ) ) AS part_size_Gb , 
    cast ( reserved_page_count * ( 0.0078125 ) AS numeric ( 18 , 2 ) ) AS reserved_size_Mb , 
    cast ( used_page_count * ( 0.0078125 ) AS numeric ( 18 , 2 ) ) AS used_size_Mb 
    FROM sys.dm_db_partition_stats 
) 
phsta 
ON pa.object_id = phsta.object_id AND pa.index_id = phsta.index_id 
AND pa.partition_number = phsta.partition_number 
-- AND prng_up.boundary_id = @PartitionNo
LEFT JOIN sys.partition_range_values prng_down ON prng_down.function_id = pf.function_id 
AND prng_down.boundary_id = pa.partition_number - 1 
LEFT JOIN sys.destination_data_spaces dds 
ON ps.data_space_id = dds.partition_scheme_id AND dds.destination_id = pa.partition_number 
LEFT JOIN sys.data_spaces ds ON isnull ( dds.data_space_id , i.data_space_id ) = ds.data_space_id 
/*  left join  sys.database_files dbf  with(nolock) 
on ds.data_space_id = dbf.data_space_id */ 
WHERE 1 = 1 
AND obj.type = 'U' 
AND 
( 
    ps.name IS NULL AND 
    ( i.index_id = 0 AND ic.partition_ordinal IS NULL OR 
        i.index_id > 0 AND ic.index_column_id = 1 ) 
    OR ps.name IS NOT NULL AND ic.partition_ordinal = 1 
)